var NE = require('nuby-express');
var util = require('util');
var _DEBUG = false;
var Gate = NE.deps.support.Gate;

var Layout_Handler_Factory = require('./Layout');

module.exports = function(){

    return new NE.Path_Handler({
        name:'layout_dir_handler',
        re:/^layout(s)?$/,
        type:'dir',
        execute:function (props, callback) {
            var layout_loader = new NE.Loader({path:props.full_path});
            var layout_handler = Layout_Handler_Factory();
            layout_loader.add_handler(layout_handler);
            var frame = props.frame;

            layout_loader.start_load(
                function () {
                    var res = layout_loader.get_resources();
                    if (_DEBUG) console.log('LAYOUT DIR found %s resources in %s', res.length, layout_loader.path);
                    if (res.length) frame.add_resources(res);
                   // console.log(layout_loader);
                    callback();
                }, props.full_path, frame
            );
        }
    });

}