var util = require('util');
var path = require('path');
var _ = require('underscore');

var NE = require('nuby-express');

var Loader = NE.Loader;
var config_handler = NE.handlers.Config;
var ress_handler = NE.handlers.Resources;
var digest_config = NE.utility.digest_config;
var ensure_name = NE.utility.ensure_name;
var views_handler = require('./handlers/View');
var heritage = NE.utility.heritage;
var _config_user = NE.utility.config_user;

var _DEBUG_LAYOUT = false;

function Layout(config) {
    if (_DEBUG_LAYOUT) console.log('layout config: %s', util.inspect(config));
    this.config = {};
    digest_config(this, config, true);
    this._init_handlers();
    if (!this.name) {
        if (/_layout$/.test(this.path)) {
            ensure_name(this, /^(.*)(_layout)$/i, 1);
        } else {
            ensure_name(this, /.*/);
        }
    }

    this.resource_read = false;

}

_.extend(Layout.prototype, Loader.prototype);
_.extend(Layout.prototype, _config_user)

_.extend(Layout.prototype, {
    CLASS:'LAYOUT',
    heritage:heritage,
    type:'layout',

    _init_handlers: function(){
        this.add_handler(views_handler(this));
        this.add_handler(config_handler());
        this.add_handler(ress_handler());
    }
});

module.exports = Layout;